import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'cx_1500n_plugin_method_channel.dart';

abstract class Cx1500nPluginPlatform extends PlatformInterface {
  /// Constructs a Cx1500nPluginPlatform.
  Cx1500nPluginPlatform() : super(token: _token);

  static final Object _token = Object();

  static Cx1500nPluginPlatform _instance = MethodChannelCx1500nPlugin();

  /// The default instance of [Cx1500nPluginPlatform] to use.
  ///
  /// Defaults to [MethodChannelCx1500nPlugin].
  static Cx1500nPluginPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [Cx1500nPluginPlatform] when
  /// they register themselves.
  static set instance(Cx1500nPluginPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<String?> connect() {
    throw UnimplementedError('connect() has not been implemented.');
  }

  Future<String?> disconnect() {
    throw UnimplementedError('disconnect() has not been implemented.');
  }

  Future<void> startInventory() {
    throw UnimplementedError('startInventory() has not been implemented.');
  }

  Future<String?> stopInventory() {
    throw UnimplementedError('stopInventory() has not been implemented.');
  }

  Stream<String> get events;

  Future<void> setPower(int power) {
    throw UnimplementedError('setPower() has not been implemented.');
  }

  Future<String> read(int power) {
    throw UnimplementedError('read() has not been implemented.');
  }

  Future<void> startScan() {
    throw UnimplementedError('startScan() has not been implemented.');
  }

  Future<void> stopScan() {
    throw UnimplementedError('stopScan() has not been implemented.');
  }
}
